%% (c) Dale Gerdemann; with few additions by Gertjan van Noord
%% not finished. experimental.
%%
%% cf. Bird and Ellison, One-level Phonology.
%% 
%% cf. Partee et al, "Mathematical Methods in
%% Linguistics" (p. 297ff) for the observation that <sigma*, union,
%% intersection, complement, {}, sigma*> is a boolean algebra.

:- multifile macro/2.

/*
%% in the calculus:
macro(if(Cond,Then,Else),
    {  range(Cond o (? * x ? *)) o Then,
      ~range(Cond o (? * x ? *)) o Else
    }).

*/
macro(if(If,Then,Else),Expr) :-
    fsa_regex:rx(minimize(If),Fa0),
    (   Fa0=fa(_,1,[0],[],[],[])     %% internal format for {}
    ->  Expr=Else
    ;   Expr=Then
    ).

macro(if(If),if(If,true,false)).

macro(boolean,{true,false}).
macro(true,? *).
macro(false,{}).

%% cf. Roche and Schabes
macro(member(String,A),if( String & A, true, false)).
macro(empty(A),if(A,false,true)).
macro(total(A), empty(~ A)).
macro(subset(A1,A2), empty(A1 & ~ A2)).
macro(equal(A1,A2), subset(A1,A2) & subset(A2,A1)).

%% now for transducers
macro(t_member(In,Out,T), ~ empty(range(In o T o Out))).
macro(t_empty(T),empty(T)).


%% Boolean is the empty language if Expr is a transducer;
%% Boolean is the universal language if Expr is a recognizer
macro(is_recognizer(Expr),Expr) :-
    regex:rx(Expr,Fa0),
    fsa_data:fsa_type(Fa0,Type),
    (   Type == recognizer
    ->  Expr= (? *)
    ;   Expr= {}
    ).

macro(is_transducer(Expr),~ is_recognizer(Expr)).

%% Dale: On a more positive note, one useful thing that can be defined
%% in the calculus is short-circuit conjunction. 
%% If Q is complicated enough, this might be a savings.

:- op(401,yfx,and).

macro(P and Q, if(P, if(Q,true,false), false)).


