#!/usr/bin/perl -w

$dfl="/cdrom3/dutch/dfl/dfl.cd";
$dmw="/cdrom3/dutch/dmw/dmw.cd";
$dow="/cdrom3/dutch/dow/dow.cd";
$dsl="./synlabel /cdrom3/dutch/dsl/dsl.cd CL 3 GE 4 DE 5 PR 6 AU 7 SV 8 SC 9 AD 10 CO 11 SP 12 |";
%dmw=();    ## mapt elke surface vorm naar lijst stam-ids
@dmw=();    ## array van DMW
@idmw=();   ## mapt elke stam-id naar lijst surface word-ids
%dow=();    ## mapt elke spelling vorm naar default spelling vorm
@dow=();    ## array van DOW 
$freq=50;
@freqs=();

print STDERR "initializing dfl...\n";
open (DFL,$dfl) || die "cannot open $dfl: $!\n";
while (<DFL>) {
  chomp;
  ($i,undef,$f,undef)=split /\\/;
  $freqs[$i]=$f;
}
close DFL;
print STDERR "initializing dfl done\n";

open (DOW,$dow) || die "cannot open $dow: $!\n";
print STDERR "initializing dow...\n";
while (<DOW>){
  chomp;
  ($i,undef)=split /\\/;
  $dow[$i]=$_;
}
close DOW;
print STDERR "initializing dow done\n";

print STDERR "initializing dmw...\n";
open (DMW,$dmw) || die "cannot open $dmw: $!\n";
while (<DMW>) {
  chomp;
  ($id,$word,$stem,$infl) = split (/\\/);
  push @{ $dmw{$word}}, $stem;
  push @{ $idmw[$stem]}, $id;
  $dmw[$id]=$_;
}
close DMW;
print STDERR "initializing dmw done\n";

open(FORM,">form");

open (DSL,$dsl) || die "cannot open $dsl: $!\n";
while (<DSL>) {
  chomp;
  my ($subcat,$dehet,$subclassp,$subclass,$prop,$aux,$adv,$gend,$cardord);
  ($stemid,$stem,$cat,$gend,$dehet,$prop,$aux,$subclass,$subcat,
   $adv,$cardord,$subclassp)=split /\\/;
  if ($freqs[$stemid] < $freq) {next;}
  foreach $id (@{$idmw[$stemid]}) {
    $an=$dmw[$id];
    (undef,$word,undef,$infl) = split /\\/, $an;
    $i=1;
    @orths=split /\\/,$dow[$id];
    @words=($orths[1]);
    if ($orths[7]) { push @words, $orths[7]}
    if ($orths[12]) { push @words, $orths[12]}
    if ($orths[17]) { push @words, $orths[17]}
    foreach $vword (@words) {
	$vword =~ s/ /*/g;
	$stem  =~ s/ /*/g;
      printf "%s %s %s_%s\n",$vword,$stem,$cat,$infl;
      $i++;
    } 
  }
}


close FORM;
