:- use_module(ge_minimise).

macro(mge(Expr),melt(mge0(incomplete(determinize0(freeze(Expr,Flag)))),Flag)).
%macro(mge(Expr),melt(mge0(complete(determinize0(freeze(Expr,Flag)))),Flag)).
%macro(mge(Expr),melt(mge0(determinize0(freeze(Expr,Flag)))),Flag)).

rx(mge0(Expr),Fa):-
    fsa_regex:rx(Expr,Fa0),
    ge_minimise(Fa0,Fa).

%% Usage:
%% e.g. minimise automaton in file n200 using this minimiser:
%% fsa -v -aux ge -mge n200 n200.m
%%
%% e.g. minimise `linear' automaton of size 1000
%% fsa -aux n -r "n(1000)" | fsa -v -aux ge -mge

:- multifile user:(user_command/4).
user:user_command(mge, fsa_regex:fsa_regex_compile_file(mge(file(User)),User2)) -->
    user:input_output(User,User2).
