constraint(L,D,R) :-
    pattern(Atom),
    atom_to_constraint(Atom,L,D,R).

atom_to_constraint(Atom,L,D,R) :-
    atom_codes(Atom,Codes),
    codes_pattern(Codes,Pattern),
    pattern_to_constraint(Pattern,L,D,R).

codes_pattern([],[]).
codes_pattern([H|T],[P|Ps]) :-
    letter_or_marker(H,P),
    codes_pattern(T,Ps).

letter_or_marker(H,P) :-
    (	H >= 48, H =< 57
    ->	number_codes(P,[H]),
	(   H > 53
	->  format(user_error,"Warning: code ~w > 5 in pattern!~n",[P])
	;   true
	)
    ;	atom_codes(P,[H])
    ).
	
pattern_to_constraint([H|T],L,D,R) :-
    (	atom(H)
    ->	L=[H|L1],
	pattern_to_constraint(T,L1,D,R)
    ;	number(H),
	(   H = D,
	    L = [],
	    remainder_pattern(T,R)
	;   pattern_to_constraint(T,L,D,R)
	)
    ).

remainder_pattern([],[]).
remainder_pattern([H|T],Rest) :-
    (	atom(H)
    ->	Rest = [H|Rest1],
	remainder_pattern(T,Rest1)
    ;	remainder_pattern(T,Rest)
    ).



