/*
grep -c 1 patterns.pl  :  785
grep -c 2 patterns.pl  : 1314
grep -c 3 patterns.pl  : 2100
grep -c 4 patterns.pl  : 2860
grep -c 5 patterns.pl  : 1828
-----------------------------
total number of simple
          patterns       8887

*/

:- multifile macro/2.

%% define replace operator.
:- ensure_loaded('../MohriSproat96/ops').
:- ensure_loaded(auxs).

%% simple example patterns
%pattern(g2sp).
%pattern(gs1p).
%pattern('1s').
%pattern('.aan5').

%% test with:
%%%% drugspand  --> drugs-pand
%%%% hangsla    --> hang-sla

:- ensure_loaded(patterns).

macro(hyphenate,
         [[]: '.', ? *, []: '.']
                   o
             insert_digits(0)
                   o
          spy(constraints(1))
                   o
          spy(constraints(2))
                   o
          spy(constraints(3))
                   o
          spy(constraints(4))
                   o
          spy(constraints(5))
                   o
          digits_to_hyphens
                   o
         ['.' :[], ? *, '.' :[]]
     ).

macro(insert_digits(N,L), range( L o cache(insert_digits(N)) )).

macro(insert_digits(N), { [] , [[ `0..5, [] x 0..N]*, `0..5 ] }).

macro(digits_to_hyphens,
         [[ ? , {{0,2,4} x [],
                 {1,3,5} x '-'} ]* ,? ]).


%% for testing: compose first N constraints 
macro(n_constraints(N,D), Intersection) :-
    findall(C, hyphen_constraint(D,C), Cs),
    length(First_N,N),
    lists:append(First_N,_,Cs),
    compose_list(First_N,Intersection).

%% compose all constraints introducing digit N
macro(constraints(N), compose_list(Cs)) :-
    findall(C, hyphen_constraint(N,C), Cs).

macro(marked,[[`0..5,0..5]*,`0..5]).

macro(simple_constraint(L,D,R),Expr) :-
    simple_constraint(L,D,R,Expr).

simple_constraint(L,D,R, cache(marked)
                               o
			 replace(insert_digits(D,L),
				 0..D0,
				 D,
				 insert_digits(D,R))
		               o
		         cache(marked)) :-
    D0 is D -1.

hyphen_constraint(N,Expr) :-
    constraint(L,N,R),
    simple_constraint(L,N,R,Expr).

