%% simple version of Karttunen 98

:- multifile macro/2.

:- ensure_loaded('../GerdemannVannoord99/replace').

macro(cons,      {b,c,d,f,g,h,j,k,l,m,n,p,q,r,s,t,v,w,x,y,z}).
macro(vowel,     {a,e,o,u,i}).

macro(o_br,    'O['). % onset
macro(n_br,    'N['). % nucleus
macro(d_br,    'D['). % coda
macro(x_br,    'X['). % unparsed
macro(r_br,    ']').
macro(bracket, {o_br,n_br,d_br,x_br,r_br}).

macro(onset,   [o_br,cons^  ,r_br]).
macro(nucleus, [n_br,vowel^ ,r_br]).
macro(coda,    [d_br,cons^  ,r_br]).
macro(unparsed,[x_br, {cons,vowel} ,r_br]).

macro(gen,       {cons,vowel}* 
                       o 
          intro_each_pos([{o_br,d_br,n_br},r_br]^)   
                       o 
                     parse 
                       o 
     ignore([onset^,nucleus,coda^],unparsed)*      ).

macro(parse, replace([[] x {o_br,d_br,x_br},cons, [] x r_br])
                                 o
             replace([[] x {n_br,x_br},     vowel,[] x r_br])).

macro(intro_each_pos(E), [[ [] x E, ?]*,[] x E]).

macro(no_coda,~ $ 'D[').

macro(parsed,~ $ 'X[').

macro(fill_nuc, ~ $ ['N[', ']']).

macro(fill_ons, ~ $ ['O[', ']']).

macro(have_ons, ~[~[? *,onset],nucleus,? *] ).

macro(priority_union(Q,R), {Q, ~domain(Q) o R}).

macro(lenient_composition(R,C), priority_union(R o C,R)).

%% equivalent, but efficient version of lenient_composition
macro(R0 lc C0, pragma([R-R0,C-C0], {R o C, ~domain(R o C) o R} )).


:- op(403,yfx,lc).

macro(lenient, gen
                  lc
               have_ons
                  lc
                no_coda
                  lc
               fill_nuc
                  lc
               parsed
                  lc
               fill_ons
     ).
