%% by Gertjan van Noord vannoord@let.rug.nl
%% ----------------------------------------
%% Chosing a different `data-structure' makes things easier. ( Obviously,
%% given that this is a `finite' problem we can cheat as much as we want, 
%% so this is not a better solution, simply a different one which happen
%% to work well in the sense that we get a solution before memory runs
%% out :-). It's also slightly more interesting than the solution
%% {[2,4,1,3],[3,1,4,2]}.

:- multifile macro/2.

macro(sigma,{1,2,3,4}).


macro(constraint(Expr),
      sigma* - [sigma*,Expr,sigma*]).

macro(length_four,[sigma,sigma,sigma,sigma]).

macro(columns,
      constraint([1,sigma*,1])     &
      constraint([2,sigma*,2])     &
      constraint([3,sigma*,3])     &
      constraint([4,sigma*,4])
     ).

macro(four_queens_problem, 
     length_four                   &
     columns                       &
     diagonals                     &
     reverse(diagonals)          

 ). 

macro(diagonals, 
     constraint([1,2])             &
     constraint([2,3])             &
     constraint([3,4])             &
     constraint([1,sigma,3])       &
     constraint([2,sigma,4])       &
     constraint([1,sigma,sigma,4])
     ).
