%% by Gertjan van Noord vannoord@let.rug.nl
%% ----------------------------------------
%% c.f. fourq_gj.pl for the case which only treats N=4. That
%% version can be said to document this version.

:- multifile macro/2.
:- discontiguous macro/2.

macro(free(Expr),~ $ Expr).

macro(length(N),List) :-
    length(List,N),
    fill_qm(List).

fill_qm([]).
fill_qm([ ? | T]) :-
    fill_qm(T).

macro(sigma(N),set(L)):-
    findall(C,fsa_util:between(1,N,C),L).

macro(columns(N), Intersection) :-
    columns(1,N,Intersection).

columns(N,N,free([N,? *,N])).
columns(N0,N,free([N0,? *,N0]) & Intersect) :-
    N0<N,
    is(N1,+(N0,1)),
    columns(N1,N,Intersect).

macro(n_queens(N), 
      sigma(N)*                     &
      length(N)                     &
      columns(N)                    &
      diagonals(N)                  &
      reverse(diagonals(N))
 ). 

macro(diagonals(N), Intersection) :-
    diagonals(1,N,Intersection).

diagonals(N0,N,I) :-
    is(N,+(N0,1)),!,
    diagonals_n(1,N0,N,I).
diagonals(N0,N,I0 & I) :-
    diagonals_n(1,N0,N,I0),
    is(N1,+(N0,1)),
    diagonals(N1,N,I).

%%diagonals_n(Start,Dif,End)
%%rule out [Start,...,Dif]
diagonals_n(N0,Br,N,I0) :-
    is(N,+(N0,Br)),!,
    diagonal(N0,Br,I0).    
diagonals_n(N0,Br,N,I0 & I):-
    diagonal(N0,Br,I0),
    is(N1,+(N0,1)),
    diagonals_n(N1,Br,N,I).

diagonal(N0,Br,free([N0,length(MidN),N])) :-
    is(N,+(N0,Br)),
    is(MidN,-(Br,1)).

