fsmnlp(File,Alg):-
    statistics(runtime,[T0,_]),
    fsa_io:fsa_read_file(File,Fa0),
    statistics(runtime,[T1,_]),
    fsa_data:fsa_states_number(Fa0,States),
    fsa_data:fsa_transitions(Fa0,Trans0), length(Trans0,Trans),
    fsa_data:fsa_jumps(Fa0,Jumps0),       length(Jumps0,Jumps),
    fsa_data:fsa_symbols_number(Fa0,Symbols),
    Det is Trans/(States*Symbols),
    J is Jumps/States,
    format("~3f ~3f ",[Det,J]),
    statistics(runtime,[T1a,_]),
    fsa_determinizer:determinize(Fa0,Fa,Alg),
    statistics(runtime,[T2,_]),
    fsa_io:fsa_write_file('/dev/null',Fa),
    statistics(runtime,[T3,_]),
    TimeIo is T1-T0 + T3-T2,
    TimeComp is T2-T1a,
    Time is TimeComp+TimeIo,
    fsa_data:fsa_states_number(Fa,NewStates),
    format("~w (~w) ~w~n",[Time,TimeIo,NewStates]),
    halt.
