/* This file is generated automatically by FSA Utilities.
 * (c) 1993 - 1999 Gertjan van Noord RUG
 * More information from http://www.let.rug.nl/~vannoord/Fsa/
 * 
 * The representation of the finite-automaton is
 * similar to the technique explained on page 43 (table
 * 4.2) of Jan Daciuk's dissertation `Incremental
 * Construction of Finite-State Automata and Transducers
 * and their use in the Natural Language Processing'.
 * Politechnika Gdanska, 1998.
 */


#include <string.h>
int accepts(char *in) {

  static struct transition_struct {
    int symbol;      /* current symbol                     */
    int nr;          /* number of lines relevant for next  */
    int final;       /* final state?                       */
    int next;        /* line in table to go to next        */
  } trans[]= {
                     /* sink                               */
    {0,1,0,0},
                     /* start state                        */
    {0,2,1,2},
                     /* normal transitions                 */
    {97,1,0,5},
    {98,1,0,6},
    {98,1,0,6},
    {97,2,1,2},
    {98,1,1,4},
    };
  register int i,c,line,nr;
  line=1;
  nr=1;
  i=0;
  c=in[i];
  while (c != '\0') {
    nr=trans[line].nr;                  /* find transition */
    line=trans[line].next;
    while (nr>1 && c != trans[line].symbol) {  
      line++;
      nr--;
    }
    if (c != trans[line].symbol) line=0;           /* sink */
    i++;
    c=in[i];
  }
  if (trans[line].final) {         /* we're at final state */
    return 0;
  } else {
    return 1;
  }
}



#include <stdio.h>
#define MAXLINE 1024        /* this constrains line length */
int main() {
  char in[MAXLINE];

  while(fgets(in,MAXLINE,stdin) != NULL) {
    in[strlen(in)-1] = '\0';                      /* chop */
    if (accepts(in)==0) 
      fprintf(stderr,"yes\n");
    else
      fprintf(stderr,"no\n");
  }                                         /* end-of-file */
  return 0;
}

