package FSA;

import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.io.*;
import FSA.*;

public class DFAapplet extends Applet 
{

    /* this is for running the applet from main */
    public void gui()
    {
	Frame f = new Frame("Test a finite automaton");
	init();
	f.add("Center",this);
	final Button ok=new Button("Done"); 
	ok.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent evt){
		    System.exit(0);
		}});
	f.add("South",ok);
	f.pack();
	f.setVisible(true);
    }  

    private DFA aut;

    public DFA automaton() {
	return aut;
    }




    /* constructor requires a DFA argument */
    public DFAapplet(DFA automaton)
    { 
	aut = automaton;

	setLayout(new BorderLayout());
	final TextField tf=new TextField(30);
	final Label n=new Label("");
	final Label w=new Label("       ");
	final Label l=new Label("Type in a String:");
	tf.addActionListener(new ActionListener()
	    {
		public void actionPerformed(ActionEvent evt){
		    String line = tf.getText();
		    if (aut.Recognizer()) 
			if (aut.accepts(line)) {
			    n.setBackground(Color.green);
			    n.setText("Yes!");
			}
			else {
			    n.setBackground(Color.red);	
			    n.setText("No!");
			}
		    else if (aut.Transducer()) {
			String out = aut.transduces(line);
			if (out != null) {
			    n.setBackground(Color.green);
			    n.setText(out);
			}
			else {
			    n.setBackground(Color.red);	
			    n.setText("No!");
			}
		    }
		    else if (aut.WeightedRecognizer()) {
			Integer out = aut.weighs(line);
			if (out != null) {
			    n.setBackground(Color.green);
			    w.setText(out.toString());
			}
			else {
			    n.setBackground(Color.red);	
			    w.setText("No!");
			}
		    }
		    else if (aut.WeightedTransducer()) {
			StringWeightPair pair = aut.string_weight(line);
			if (pair != null) {
			    n.setBackground(Color.green);
			    n.setText(pair.out_string);
			    w.setText(pair.weight.toString());
			}
			else {
			    n.setBackground(Color.red);	
			    n.setText("No!");
			    w.setText("No!");
			}
		    }
		}
	    });
	add("South",n);
	add("East",w);
	add("Center",tf);
	add("North",l);
	setVisible(true);
    }
}




    
