%% purpose of this file is twofold
%% -provide dummy definitions of hook predicates
%% -provide public declarations of unused (but useful) (library) predicates

:- public tcltk:tcl_new/1,  tcltk:tcl_delete/1,  tcltk:tcl_eval/3,
    tcltk:tcl_event/3,  tcltk:tk_new/2,  tcltk:tk_main_window/2,
    tcltk:tk_destroy_window/1,  tcltk:tk_make_window_exist/1,
    tcltk:tk_num_main_windows/1,  tcltk:tk_do_one_event/0,
    tcltk:tk_do_one_event/1,  tcltk:tk_next_event/2,  tcltk:tk_next_event/3, 
    tcltk:tk_main_loop/0, tcltk:tk_terminal/5,
    tcltk:read_sc/2, tcltk:write_sc/2, tcltk:writeq_sc/2,
    tcltk:write_canonical_sc/2, tcltk:format_sc/3,
    tcltk:call_from_tcl/1, tcltk:add_result/2.

:- public lists:append/3, lists:delete/3, lists:is_list/1, lists:last/2, 
    lists:member/2, lists:memberchk/2, lists:nextto/3, lists:no_doubles/1, 
    lists:non_member/2, lists:nth/3, lists:nth/4, lists:nth0/3, lists:nth0/4, 
    lists:permutation/2, lists:prefix/2, lists:remove_duplicates/2, 
    lists:reverse/2, lists:same_length/2, lists:same_length/3, lists:select/3, 
    lists:sublist/2, lists:substitute/4, lists:suffix/2, lists:max_list/2, 
    lists:min_list/2, lists:sum_list/2.

:- public assoc:assoc_to_list/2, assoc:empty_assoc/1, assoc:del_assoc/4, 
    assoc:del_max_assoc/4, assoc:del_min_assoc/4, assoc:gen_assoc/3, 
    assoc:get_assoc/3, assoc:get_assoc/5, assoc:get_next_assoc/4, 
    assoc:get_prev_assoc/4, assoc:is_assoc/1, assoc:list_to_assoc/2, 
    assoc:map_assoc/2, assoc:map_assoc/3, assoc:max_assoc/3, 
    assoc:min_assoc/3, assoc:ord_list_to_assoc/2, assoc:put_assoc/4.

:- public ordsets:is_ordset/1, ordsets:list_to_ord_set/2,
    ordsets:ord_add_element/3, ordsets:ord_del_element/3,
    ordsets:ord_disjoint/2, ordsets:ord_intersect/2,
    ordsets:ord_intersection/3, ordsets:ord_intersection/4,
    ordsets:ord_intersection/2, ordsets:ord_member/2,
    ordsets:ord_seteq/2, ordsets:ord_setproduct/3,
    ordsets:ord_subset/2, ordsets:ord_subtract/3,
    ordsets:ord_symdiff/3, ordsets:ord_union/3,
    ordsets:ord_union/4, ordsets:ord_union/2.

:- public fastrw:fast_read/1, fastrw:fast_read/2, fastrw:fast_write/1,
    fastrw:fast_write/2,fastrw:fast_buf_read/2,fastrw:fast_buf_write/3,
    fastrw:init_fastrw/1, fastrw:deinit_fastrw/1.

:- public system:now/1, system:datime/1, system:datime/2, system:environ/2,
    system:host_name/1, system:host_id/1, system:file_exists/1,
    system:file_exists/2, system:file_property/2, system:rename_file/2,
    system:delete_file/1, system:delete_file/2, system:make_directory/1,
    system:working_directory/2, system:directory_files/2, system:mktemp/2,
    system:tmpnam/1, system:system/0, system:system/1, system:system/2,
    system:shell/0, system:shell/1, system:shell/2, system:exec/3,
    system:popen/3, system:sleep/1, system:pid/1, system:kill/2, system:wait/2,
    system:setenv/2, system:c_setenv/3, system:sp_win32_times/3,system:signal/2,
    system:handle_signal/1,system:sp_signal/3.

system:signal_handler(_,_).

:- public terms:subsumes_chk/2, terms:subsumes/2, terms:variant/2,
    terms:term_subsumer/3, terms:term_hash/2, terms:term_hash/4,
    terms:term_variables/2, terms:term_variables_bag/2, terms:acyclic_term/1,
    terms:cyclic_term/1.

:- public random:getrand/1, random:setrand/1, random:random/1, 
    random:random/3, random:randseq/3, random:randset/3.

charsio:'$init_charsio_stream'(_,_).

fsa_interpreter_aux:accepts(_).
fsa_interpreter_aux:t_accepts(_,_).
fsa_interpreter_aux:w_accepts(_,_).
fsa_interpreter_aux:wt_accepts(_,_,_).

fsa_io_in:final(_).
fsa_io_in:jump(_,_).
fsa_io_in:start(_).
fsa_io_in:trans(_,_,_).

user:user_command(_,_,_,_).

fsa_regex_aux:rx(_,_).
fsa_regex_aux:macro(_,_).

fsa_regex_aux:prepare_reachable(_,_,_,_,_).
fsa_regex_aux:prepare_reachable(_,_,_,_,_,_).
fsa_regex_aux:is_final_reachable(_,_,_,_).
fsa_regex_aux:trans_reachables(_,_,_,_).

fsa_regex_aux:prepare_co_reachable(_,_,_,_,_).
fsa_regex_aux:is_start_co_reachable(_,_,_,_).
fsa_regex_aux:trans_co_reachables(_,_,_,_).

fsa_regex_aux:protected(_,_,_).

bit_preds:true(_).
bit_preds:regex_notation_to_predicate(_,_).
bit_preds:talks_about(_,_).
bit_preds:evaluate_predicate(_,_).
bit_preds:conjunction(_,_,_).
bit_preds:negation(_,_).
bit_preds:display_predicate(_,_).
bit_preds:prepare_complement_of_set(_,_).
bit_preds:complement_of_set(_,_,_).
bit_preds:determinize_preds(_,_).
bit_preds:t_determinize_preds(_,_).
bit_preds:identity(_,_).
bit_preds:class_to_pred(_,_).
bit_preds:negated_class_to_pred(_,_).
bit_preds:cleanup(_,_).

bit_types:true(_).
bit_types:regex_notation_to_predicate(_,_).
bit_types:talks_about(_,_).
bit_types:evaluate_predicate(_,_).
bit_types:conjunction(_,_,_).
bit_types:negation(_,_).
bit_types:display_predicate(_,_).
bit_types:prepare_complement_of_set(_,_).
bit_types:complement_of_set(_,_,_).
bit_types:determinize_preds(_,_).
bit_types:t_determinize_preds(_,_).
bit_types:identity(_,_).
bit_types:class_to_pred(_,_).
bit_types:negated_class_to_pred(_,_).
bit_types:cleanup(_,_).

fsa_preds_bbb:true(_).
fsa_preds_bbb:regex_notation_to_predicate(_,_).
fsa_preds_bbb:talks_about(_,_).
fsa_preds_bbb:evaluate_predicate(_,_).
fsa_preds_bbb:conjunction(_,_,_).
fsa_preds_bbb:negation(_,_).
fsa_preds_bbb:display_predicate(_,_).
fsa_preds_bbb:prepare_complement_of_set(_,_).
fsa_preds_bbb:complement_of_set(_,_,_).
fsa_preds_bbb:determinize_preds(_,_).
fsa_preds_bbb:t_determinize_preds(_,_).
fsa_preds_bbb:identity(_,_).
fsa_preds_bbb:class_to_pred(_,_).
fsa_preds_bbb:negated_class_to_pred(_,_).
fsa_preds_bbb:cleanup(_,_).

fsa_preds_i:true(_).
fsa_preds_i:regex_notation_to_predicate(_,_).
fsa_preds_i:talks_about(_,_).
fsa_preds_i:evaluate_predicate(_,_).
fsa_preds_i:conjunction(_,_,_).
fsa_preds_i:negation(_,_).
fsa_preds_i:display_predicate(_,_).
fsa_preds_i:prepare_complement_of_set(_,_).
fsa_preds_i:complement_of_set(_,_,_).
fsa_preds_i:determinize_preds(_,_).
fsa_preds_i:t_determinize_preds(_,_).
fsa_preds_i:identity(_,_).
fsa_preds_i:class_to_pred(_,_).
fsa_preds_i:negated_class_to_pred(_,_).
fsa_preds_i:cleanup(_,_).

types:true(_).
types:regex_notation_to_predicate(_,_).
types:talks_about(_,_).
types:evaluate_predicate(_,_).
types:conjunction(_,_,_).
types:negation(_,_).
types:display_predicate(_,_).
types:prepare_complement_of_set(_,_).
types:complement_of_set(_,_,_).
types:determinize_preds(_,_).
types:t_determinize_preds(_,_).
types:identity(_,_).
types:class_to_pred(_,_).
types:negated_class_to_pred(_,_).
types:cleanup(_,_).
