
#swi# fsa_strip_module(Term,Module0,Module,Term1) :-
#swi#     (   Term=Module1:Term1
#swi#     ->  fsa_strip_module(Term1,Module1,Module,Term1)
#swi#     ;   Term=Term1, Module0=Module
#swi#     ).

%% UNKNOWN predicates
#!swi# :- multifile unknown_predicate_handler/3.
#!swi# 
#!swi# unknown_predicate_handler(Goal,Module,Goal2) :-
#!swi#     %% only try Module:unknown_predicate_handler if it
#!swi#     %% indeed exists, otherwise we get into a loop...
#!swi#     current_predicate(unknown_predicate_handler,
#!swi# 		      Module:unknown_predicate_handler(_,_)),
#!swi#     Module:unknown_predicate_handler(Goal,Goal2).
#swi# exception(undefined_predicate,In,FailRetry) :-
#swi#     fsa_strip_module(In,user,Module,Name/Arity),
#swi#     functor(Goal,Name,Arity),
#swi#     Module:current_predicate(unknown_predicate_handler,
#swi# 			     unknown_predicate_handler(_,_)),
#swi#     Module:unknown_predicate_handler(Goal,Goal2),
#swi#     (	Goal==Goal2
#swi#     ->	FailRetry=retry
#swi#     ;   FailRetry=fail
#swi#     ).
#swi#

%% portray FSA error messages
#!swi# :- multifile portray_message/2.
#!swi# portray_message(error,fsa_error(Term,Args)):-
#!swi#     !,
#!swi#     format(user_error,"** FSA error: ",[]),
#!swi#     format(user_error,Term,Args).
#!swi#
#swi# :- use_module(charsio,[ format_to_chars/3 ]).
#swi# :- multifile prolog:message/3.
#swi# prolog:message(fsa_error(Format,Args)) -->
#swi#     { charsio:format_to_chars(Format,Args,Chars),
#swi#       atom_codes(Atom,Chars)
#swi#     },
#swi#     [Atom].
#swi# 



    
#swi# %% BLACKBOARD PRIMITIVES
#swi# :- op(1150,fx,public).
#swi# :- op(1150,fx,meta_predicate).
#swi# :- dynamic ' bb '/3.
#swi# :- meta_predicate bb_put(:,?).
#swi# bb_put(Key0,Val) :-
#swi#     fsa_strip_module(Key0,user,Module,Key),
#swi#     retractall(' bb '(Key,Module,_)),
#swi#     !,   % in case non-ISO update semantics
#swi#     assertz(' bb '(Key,Module,Val)).
#swi# 
#swi# :- meta_predicate bb_delete(:,?).
#swi# bb_delete(Key0,Val) :-
#swi#     fsa_strip_module(Key0,user,Module,Key),
#swi#     retract(' bb '(Key,Module,Val0)),
#swi#     !,   % for non-ISO update semantics
#swi#     Val0=Val.
#swi# 
#swi# :- meta_predicate bb_get(:,?).
#swi# bb_get(Key0,Val) :-
#swi#     fsa_strip_module(Key0,user,Module,Key),
#swi#     ' bb '(Key,Module,Val0),
#swi#     !,   % poor indexing
#swi#     Val0=Val.
#swi# 
#swi# bb_update(Key,Val0,Val) :-
#swi#     bb_get(Key,Val0),
#swi#     bb_put(Key,Val).

#yap# %% CALL_CLEANUP
#yap# 
#yap# %% meta - should do module expansion
#yap# :- meta_predicate call_cleanup(:,:).
#yap# call_cleanup(Call,Clean) :-
#yap#     catch((Call -> Clean;(Clean,fail)),
#yap# 	  Exc,
#yap# 	  ( call(Clean), throw(Exc))
#yap# 	 ).
#yap# 
#swi# %% MUTABLES
#swi# create_mutable(Value,'$mutable'(Value,_)).
#swi# 
#swi# get_mutable(Value,'$mutable'(Value,_)).
#swi# 
#swi# update_mutable(Value,Mutable):-
#swi#     functor(Mutable,'$mutable',2),
#swi#     setarg(1,Mutable,Value).
#swi# 

#swi# %% FORMAT @
#swi# :- format_predicate(@,format_goal(_,_)).
#swi# 
#swi# format_goal(_,Goal) :-
#swi#     call(Goal).
#swi# 

#swi# %% FINDALL/4
#swi# :- meta_predicate findall(?,:,?,?).
#swi# findall(X,Call,Sol0,Sol) :-
#swi#     findall(X,Call,Sol1),
#swi#     append(Sol1,Sol,Sol0).
#swi# 

#yap# :- yap_flag(update_semantics,logical).

:- use_module([
     fsa_array,          fsa_m_array,          fsa_u_array,
     fsa_hash,           fsa_m_hash,           fsa_u_hash,
     set_bbbtree,        map_bbbtree,
     fsa_regex,          fsa_cleanup,
     fsa_pred_module,    fsa_preds,            fsa_frozen,
     fsa_io,
     fsa_semiring,       fsa_weighted_strings, fsa_strings,  fsa_weights,
     fsa_data,
     fsa_compiler,
     fsa_compiler_to_c,  fsa_cpp,              fsa_java,     fsa_fl,
     fsa_globals,
     fsa_determinizer,   fsa_minimizer,
     fsa_dict,
     fsa_interpreter,
     fsa_t_determinizer, fsa_minimum_path,     fsa_sync,             

     fsa_visualization,
     fsa_util
	      ]).



#!sic# :- consult(fsa_version).
#sic# :- use_module(fsa_version).

