:- module(fsa_array, [fsa_array_new/2,
		      fsa_array_access/3,
		      fsa_array_access/4,
		      fsa_array_get/3,
		      fsa_array_to_list/2
		     ]).


fsa_array_new(Array,Size):-
    user:array(Array,Size).

fsa_array_access(Index,Val,Array) :-
    user:array_element(Array,Index,Val).

fsa_array_access(Index,Val,Default,Array):-
    user:array_element(Array,Index,Val0),
    (	var(Val0)
    ->	Val=Default
    ;   Val0=Val
    ).

fsa_array_get(Index,Val,Array):-
    user:array_element(Array,Index,Val),
    nonvar(Val).

fsa_array_to_list(Array,List):-
    fsa_array_to_list(0,Array,List).

fsa_array_to_list(I,Array,List) :-
    (	array_element(Array,I,El)
    ->	List=[El|Tail],
	I1 is I+1,
	fsa_array_to_list(I1,Array,Tail)
    ;   List=[]
    ).
