:- module(fsa_m_array, [fsa_m_array_new/2,
			fsa_m_array_get/3,
			fsa_m_array_get/4,
			fsa_m_array_put/3,
			fsa_m_array_put/5
		       ]).

fsa_m_array_new(T,Size) :-
    user:array(T,Size).

fsa_m_array_get(Index,Val,Array) :-
    fsa_m_array_get(Index,Val,_,Array).

fsa_m_array_get(Index,Val,Default,Array):-
    user:array_element(Array,Index,Val0),
    (	var(Val0)
    ->	Val=Default
    ;   Val0=Val
    ).

fsa_m_array_put(Index,Val,Array) :-
    user:update_array(Array,Index,Val).

fsa_m_array_put(Index,Old,Default,Val,Array) :-
    user:array_element(Array,Index,Val0),
    (	var(Val0)
    ->	Old=Default
    ;   Old=Val0
    ),
    user:update_array(Array,Index,Val).

